#ifndef PUBLIC_CRB_DEV_H_INCLUDED
#define PUBLIC_CRB_DEV_H_INCLUDED

#define PRIVATE_CROWBAR_H_INCLUDED

typedef enum {
    CRB_FALSE = 0,
    CRB_TRUE = 1
} CRB_Boolean;

typedef struct CRB_String_tag {
    int         ref_count;
    char        *string;
    CRB_Boolean is_literal;
} CRB_String;

typedef enum {
    CRB_INT_VALUE = 1,
    CRB_DOUBLE_VALUE,
    CRB_STRING_VALUE,
    CRB_NULL_VALUE
} CRB_ValueType;

typedef struct {
    CRB_ValueType       type;
    union {
        int     int_value;
        double  double_value;
        CRB_String      *string_value;
    } u;
} CRB_Value;

typedef CRB_Value CRB_NativeFunctionProc(CRB_Interpreter *interpreter,
                                         int arg_count, CRB_Value *args);

void CRB_add_native_function(CRB_Interpreter *interpreter,
                             char *name, CRB_NativeFunctionProc *proc);

#endif /* PUBLIC_CRB_DEV_H_INCLUDED */
