#include <stdio.h>
#include "MEM.h"
#include "DBG.h"
#include "crowbar.h"

CRB_Value crb_nv_print_proc(CRB_Interpreter *interpreter,
                            int arg_count, CRB_Value *args)
{
    CRB_Value value;

    value.type = CRB_NULL_VALUE;

    if (arg_count < 1) {
        crb_runtime_error(0, ARGUMENT_TOO_FEW_ERR,
                          MESSAGE_ARGUMENT_END);
    } else if (arg_count > 2) {
        crb_runtime_error(0, ARGUMENT_TOO_MANY_ERR,
                          MESSAGE_ARGUMENT_END);
    }
    switch (args[0].type) {
    case CRB_INT_VALUE:
        printf("%d", args[0].u.int_value);
        break;
    case CRB_DOUBLE_VALUE:
        printf("%f", args[0].u.double_value);
        break;
    case CRB_STRING_VALUE:
        printf("%s", args[0].u.string_value->string);
        break;
    case CRB_NULL_VALUE:
        printf("null");
        break;
    }

    return value;
}
